<?
class apk_file
{
	var $fp;
	var $pp;
	var $path;
	var $mode;

	function open($path, $mode = "r")
	{
		$this->fp = fopen($path, $mode);
		if(is_resource($this->fp))
		{
			$this->path = $path;
			$this->mode = $mode;
			return TRUE;
		}

		return FALSE;
	}

	function close()
	{
		return fclose($this->fp);
	}

	function pipe_close()
	{
		return pclose($this->fp);
	}

	function write($data)
	{
		return fwrite($this->fp, $data);
	}

	function read($len)
	{
		return fread($this->fp, $len);
	}

	function open_pipe_from($command)
	{
		$this->pipe = popen($command, "r");
	}

	function open_pipe_to($command)
	{
		$this->pipe = popen($command, "w");
	}

	function pipe_to()
	{
		while(($data = fread($this->fp, 4096)))
		{
			fwrite($this->pp, $data);
		}
	}

	function pipe_from()
	{
		while(($data = fread($this->pp, 4096)))
		{
			fwrite($this->fp, $data);
		}
	}

	function &temp($prefix = "apk", $path = "/tmp")
	{
		list($usec, $sec) = explode(' ', microtime());
		mt_srand(((double)$sec) + ((double)($usec * 100000)));
		$rnd1 = md5sum(mt_rand()).time();
		list($usec, $sec) = explode(' ', microtime());
		mt_srand(((double)$sec) + ((double)($usec * 100000)));
		$rnd2 = md5sum(mt_rand()).time();

		$tmpp = $path."/".$prefix."_".$rnd1.$rnd2;
		$obj = &new apk_file;
		$obj->open($tmpp, "w");
		return $obj;
	}

	function lock($timeout = 5)
	{
		$sleeptime = 1;
		$l = FALSE;

		if(is_resource($this->fp))
		{
			while($timeout && !$l)
			{
				$l = flock($this->fp, LOCK_EX);
				$timeout--;
				if(!$l) sleep($sleeptime);
				$sleeptime = $timeout * 2;
			}
		}

		return $l;
	}

	function unlock()
	{
		if(is_resource($this->fp))
			flock($this->fp, LOCK_UN);
	}
}

?>
